/****************************************************************************
 
  Header file for template Flat Sate Machine 
  based on the Gen2 Events and Services Framework

 ****************************************************************************/

#ifndef CoachProtocolFSM_H
#define CoachProtocolFSM_H

// Event Definitions
#include "ES_Configure.h" /* gets us event definitions */
#include "ES_Types.h"     /* gets bool type for returns */

// typedefs for the states
// State definitions for use with the query function
typedef enum { InitProtocolState, ProtocolIdle, 
               WaitPair, Paired } CoachProtocolState_t ;


// Public Function Prototypes

bool InitCoachProtocolFSM ( uint8_t Priority );
bool PostCoachProtocolFSM( ES_Event ThisEvent );
ES_Event RunCoachProtocolFSM( ES_Event ThisEvent );
CoachProtocolState_t QueryCoachProtocolFSM ( void );



#endif /* CoachProtocol_H */

