/****************************************************************************
 
  Header file for template Flat Sate Machine 
  based on the Gen2 Events and Services Framework

 ****************************************************************************/

#ifndef PICUartRx_H
#define PICUartRx_H

// Event Definitions
#include "ES_Configure.h" /* gets us event definitions */
#include "ES_Types.h"     /* gets bool type for returns */

// typedefs for the states
// State definitions for use with the query function
typedef enum { InitPRXState, Wait0x7E, WaitMSB, WaitLSB,
               SuckBody, WaitCheckSum} PICUartRxState_t ;


// Public Function Prototypes

bool InitPICUartRxFSM ( uint8_t Priority );
bool PostPICUartRxFSM( ES_Event ThisEvent );
ES_Event RunPICUartRxFSM( ES_Event ThisEvent );
PICUartRxState_t QueryPICUartRxFSM ( void );

// Access to RX Packet
uint8_t RX_getXBeePacket( uint8_t _index );
uint8_t RX_getLength( void );

// Access control for RX Packet
bool RX_getLock( void );
void RX_releaseLock( void );

#endif /* PICUartRx_H */

