/****************************************************************************
 
  Header file for template Flat Sate Machine 
  based on the Gen2 Events and Services Framework

 ****************************************************************************/

#ifndef PICUartTxFSM_H
#define PICUartTxFSM_H

// Event Definitions
#include "ES_Configure.h" /* gets us event definitions */
#include "ES_Types.h"     /* gets bool type for returns */
#include "ES_Events.h"

// typedefs for the states
// State definitions for use with the query function
typedef enum { InitPTXState, Idle, SendMSG, WaitTXStatus} PICUartTxState_t ;


// Public Function Prototypes

bool InitPICUartTxFSM ( uint8_t Priority );
bool PostPICUartTxFSM( ES_Event ThisEvent );
ES_Event RunPICUartTxFSM( ES_Event ThisEvent );
PICUartTxState_t QueryPICUartTxFSM ( void );
                      
bool TX_clearXBeePacket( void );
bool TX_appendXBeePacket( uint8_t newByte );
uint8_t TX_getXBeePacket( uint8_t _index );
uint8_t TX_getLength( void );
uint8_t TX_getChecksum( void );

// Public variables
extern uint8_t XBeePacket[];
extern uint8_t TX_length;
extern uint8_t TX_index;
                      

#endif /* PICUartRx_H */

