/****************************************************************************
 
  Header file for template Flat Sate Machine 
  based on the Gen2 Events and Services Framework

 ****************************************************************************/

#ifndef PIC_SPI_FSM_H
#define PIC_SPI_FSM_H

// Event Definitions
#include "ES_Configure.h" /* gets us event definitions */
#include "ES_Types.h"     /* gets bool type for returns */

// typedefs for the states
// State definitions for use with the query function
typedef enum { InitPSPIState, WaitingForSlaveSelectHigh /*, WaitingForHeaderByte, WaitingForDataByte*/ } PIC_SPI_FSMState_t ;


// Public Function Prototypes

bool InitPIC_SPI_FSM ( uint8_t Priority );
bool PostPIC_SPI_FSM( ES_Event ThisEvent );
ES_Event RunPIC_SPI_FSM( ES_Event ThisEvent );
PIC_SPI_FSMState_t QueryTemplateSM ( void );

signed char GetCurrentSpeed(void);
signed char GetCurrentOrientation(void);
unsigned char GetCurrentStatus(void);
void SetCurrentStatus(unsigned char NewStatus);
void ClearCurrentStatus(void);
unsigned char GetCurrentAux(void);
void ClearAux(void);

// Public variables
extern unsigned char ReceivedBytes[];
extern unsigned char ByteIndex;
extern unsigned char CurrentStatus;

#endif /* PIC_SPI_FSM_H */

