#include <stdio.h>
#include "ES_Configure.h"
#include "ES_Framework.h"
#include "SPI.h"

__CONFIG( FCMEN_OFF & IESO_OFF & BOREN_OFF & CPD_OFF & CP_OFF & MCLRE_ON & PWRTE_OFF & WDTE_OFF & FOSC_HS);

void main( void) {
ES_Return_t ErrorType;

// When doing testing, it is usefull to annouce just which program
// is running.
//puts("Starting Test Harness for \r");
//puts("the 2nd Generation Events & Services Framework V2.1\r");
//puts(__TIME__ " " __DATE__);
//puts("\n\r");
//puts("Press 1 to post key-stroke events to Service 1\r");
//puts("Press 0 to post key-stroke events to Service 0\n\r");

// Your hardware initialization function calls go here

/***ANALOG***/
ANSEL = 0x00;  //make all port digital
ANSELH = 0x00; //make all ports digital

/*** UART ***/
//initialize the SCI1 UART peripheral in 8-bit, 1-stop bit, async
// at 9600 baud
BAUDCTL = BIT3HI; //set BRG16 hi
SPBRG = 129;	//sets 9615 baud rate with a 20MHz crycstal osc
RCSTA = ( BIT7HI | BIT4HI ); // SPEN, CREN, !RX9, !ADDEN
TXSTA = ( BIT5HI ); // !Tx9, !SYNC, !SENDB, TXEN, BRGH
TRISB &= BIT7LO; //set TX line to be an output

TRISA = (BIT0LO & BIT1LO & BIT2LO) ;	//set PORTA0 and A1 to outputs
PORTA = 0;  //Set PORTA is low

TRISC &= BIT4LO; //set PORTC to a digital out, this is to turn on the XBee
PORTC |= BIT4HI; // Turn the Xbee on
// for debugging
//TRISC &= ( BIT0LO & BIT1LO );
//PORTC &= ( BIT0LO & BIT1LO );

// initially disable TX interrupts and clear the flag
TXIE = 0;
TXIF = 0;

/*** SSP ***/
InitSPI();

// now initialize the Events and Services Framework and start it running
ErrorType = ES_Initialize(ES_Timer_RATE_1MS);
if ( ErrorType == Success ) {

  ErrorType = ES_Run();

}
//if we got to here, there was an error
switch (ErrorType){
  case FailedPost:
    //puts("Failed on attempt to Post");
    break;
  case FailedPointer:
    //puts("Failed on NULL pointer");
    break;
  case FailedInit:
    //puts("Failed Initialization");
    break;
 default:
    //puts("Other Failure");
    break;
}
for(;;)
  ;

};

/*------------------------------- Footnotes -------------------------------*/
/*------------------------------ End of file ------------------------------*/
